'use strict';

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _setImmediate2 = require('babel-runtime/core-js/set-immediate');

var _setImmediate3 = _interopRequireDefault(_setImmediate2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var nextTick;
if (typeof _setImmediate3.default === 'function') {
  nextTick = _setImmediate3.default;
} else if ((typeof process === 'undefined' ? 'undefined' : (0, _typeof3.default)(process)) === 'object' && process && process.nextTick) {
  nextTick = process.nextTick;
} else {
  nextTick = function nextTick(cb) {
    setTimeout(cb, 0);
  };
}

function nodeify(promise, cb) {
  if (typeof cb !== 'function') {
    return promise;
  }

  return promise.then(function (res) {
    nextTick(function () {
      cb(null, res);
    });
  }).catch(function (err) {
    cb(err);
  });
}
function nodeifySelf(cb) {
  return nodeify(this, cb);
}

(0, _assign2.default)(_promise2.default.prototype, {
  nodeify: nodeifySelf
});

var co = function co(genfun) {
  var gen = genfun();
  var next = function next(value) {
    var ret = gen.next(value);
    if (ret.done) return;
    ret.value(function (err, val) {
      if (err) {
        return console.error(err);
      }
      next(val);
    });
  };
  next();
};

exports.nodeify = nodeify;
exports.co = co;